#if !defined(AFX_MEM_H__108DB665_A198_11D3_BD69_EC322C7C547F__INCLUDED_)
#define AFX_MEM_H__108DB665_A198_11D3_BD69_EC322C7C547F__INCLUDED_


#endif

#define FLAG_IN_MEM     0X1
//#define FLAG_WRITE      0X2
class CProc;

VOID MAlloc ( CProc * proc, UINT uSize, BOOL bCreate = FALSE);
VOID MFree  ( CProc * proc, UINT uSegm );
VOID MRead  ( CProc * proc, UINT uSegm, UINT uOffset );
VOID MWrite ( CProc * proc, UINT uSegm, UINT uOffset );
VOID INT_AdrErr  ( CProc * proc, PSTR szErr = "" );
VOID INT_SegmErr ( CProc * proc, UINT uSegm );

VOID CreateProc   ( );
VOID Kill     ( );
VOID Select   ( );
VOID Execute  ( );
VOID Deattach ( );
VOID SwapSegm ( CProc * proc, UINT uSegm );
VOID LoadSegm ( CProc * proc, UINT uSegm, PSTR szAddText = "" );

VOID DEBUGMSG (PSTR szFormat, ... );

typedef struct  {
	CHAR		cFlagInMem,
                cFlagCreate;
    UINT		uSegmSize;
	UINT		uSwapAdr;
    UINT		uPhisAdr;
}  SEGMTABLESTRING, *PSEGMTABLESTRING;


typedef struct {
	UINT		uFlag;
    CPtrArray*  pSegmTable;
	UINT		uNumSegm;
} BUP, *PBUP;

class CProc {
    public :	
	    UINT    uID, uTemp1, uTemp2,
        	    uDemTime,
	    	    uWorkTime,
                uCodeSize, 
                uStackSize, 
                uDataSize;
        INT     nLastOper;
	    BUP		bup;
	    CProc(INT);
	    ~CProc() { };
	    VOID ExecProc(VOID);
};
    